﻿' ------------------------------------------------------------------------------
'
' FishKurs1n.VB                                           Ulrich Müller 20.06.06
'                                                         PCS1700 VB2005 Express
' Einführung in die Programmierung mit VB2005 und FishFace40
'                   am Beispiel einer Ampelsteuerung
'
' FishKurs1 : Einfache Ampel (Konsolanwendung). Ausbaustufe n : Nachtschaltung
'             Lampen : Grün = M1, Gelb = M2, Rot = M3
'             Taster : Nacht = I1 (Schließer)
'
' erforderlich : FishFa2005.DLL und umFish40.DLL
'
' ------------------------------------------------------------------------------
Imports FishFace40

Module FishKurs1n
  Private ft As New FishFace()
  Const mRot As Out = Out.M3
  Const mGelb As Out = Out.M2
  Const mGruen As Out = Out.M1
  Const iNacht As Inp = Inp.I1

  Private Sub NachtZyklus()

    ' --- Gelb blinken bei Nacht ---

    ft.SetMotor(mGelb, Dir.Ein)
    ft.Pause(700)
    ft.SetMotor(mGelb, Dir.Aus)
    ft.Pause(250)

  End Sub


  Private Sub TagZyklus()
    ' --- Normaler Ampelzyklus am Tage ---

    ' --- Ampelanzeige ---
    ft.SetMotor(mGruen, Dir.Ein)         '     Grün, 3000
    ft.Pause(3000)
    ft.SetMotor(mGruen, Dir.Aus)
    ft.SetMotor(mGelb, Dir.Ein)          '     Gelb, 1000
    ft.Pause(1000)
    ft.SetMotor(mGelb, Dir.Aus)
    ft.SetMotor(mRot, Dir.Ein)           '     Rot, 3500
    ft.Pause(3500)
    ft.SetMotor(mGelb, Dir.Ein)          '     Rot/Gelb, 1000
    ft.Pause(1000)
    ft.SetMotor(mRot, Dir.Aus)
    ft.SetMotor(mGelb, Dir.Aus)

  End Sub

  Sub Main()
    Console.WriteLine("--- FishKurs1n : gestartet ---")
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Console.WriteLine("--- Verbindung zum Interface hergestellt ---")
      Console.WriteLine("--- Ampelschleife läuft, Abbruch durch ESC-Taste ---")
      Do                                     ' --- Betriebsschleife Ampelanzeige ---
        Select Case TimeString
          ' --- Zyklusbestimmung, wenn man nicht warten will, auch mit iNacht
          Case #6:00:00 AM# To #10:00:00 PM#
            If ft.GetInput(iNacht) Then NachtZyklus() Else TagZyklus()
          Case Else
            NachtZyklus()
        End Select
      Loop Until ft.Finish()                  ' --- Ende durch ESC-Taste
    Catch eft As FishFaceException
      Console.WriteLine(eft.Message)
    End Try
    ft.CloseInterface()
    Console.WriteLine("--- Beenden durch RETURN ---")
    Console.ReadLine()
  End Sub

End Module
