﻿' ------------------------------------------------------------------------------
'
' FishKurs3.VB                                            Ulrich Müller 21.06.06
'                                                         PCS1700 VB2005 Express
' Einführung in die Programmierung mit VB2005 und FishFace40
'                   am Beispiel einer Ampelsteuerung
'
' Kreuzung (Konsolenanwendung)
'       Lampen : Grün = O1, Gelb = O2, Rot = O3, FußGrün = O4, FußRot = O5
'                QuerGrün = O6, QuerGelb = O7, QuerRot = O8
'
' erforderlich : FishFa2005.DLL und umFish40.DLL
'
' ------------------------------------------------------------------------------

Imports FishFace40

Module FishKurs3
  Private ft As New FishFace()

  Const cGruen = 1, cGelb = 2, cRot = 4
  Const cFussGruen = 8, cFussRot = 16
  Const cQuerGruen = 32, cQuerGelb = 64, cQuerRot = 128

  Private Sub TagZyklus()
    ' --- Ampelanzeige ---
    ft.SetMotors(cGruen + cFussGruen + cQuerRot)
    ft.Pause(3500)
    ft.SetMotors(cGelb + cFussRot + cQuerGelb + cQuerRot)
    ft.Pause(1000)
    ft.SetMotors(cRot + cFussRot + cQuerGruen)
    ft.Pause(3500)
    ft.SetMotors(cGelb + cRot + cFussRot + cQuerGelb)
    ft.Pause(1000)
  End Sub

  Private Sub NachtZyklus()
    ft.SetMotors(cGelb + cQuerGelb)
    ft.Pause(666)
    ft.ClearMotors()
    ft.Pause(333)
  End Sub

  Sub Main()
    Console.WriteLine("--- FishKurs2b : gestartet ---")
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Console.WriteLine("--- Verbindung zum Interface hergestellt ---")
      Console.WriteLine("--- Ampelschleife läuft, Abbruch durch ESC-Taste ---")
      Do                                     ' --- Betriebsschleife Ampelanzeige ---
        If TimeString > #6:00:00 AM# And TimeString < #10:00:00 PM# Then
          TagZyklus()
        Else
          NachtZyklus()
        End If
      Loop Until ft.Finish()                  ' --- Ende durch ESC-Taste
    Catch eft As FishFaceException
      Console.WriteLine(eft.Message)
    End Try
    ft.CloseInterface()
    Console.WriteLine("--- Beenden durch RETURN ---")
    Console.ReadLine()
  End Sub

End Module
