﻿' ------------------------------------------------------------------------------
'
' FishKurs3b.VB                                           Ulrich Müller 09.07.06
'                                                         PCS1700 VB2005 Express
' Einführung in die Programmierung mit VB2005 und FishFace40
'                   am Beispiel einer Ampelsteuerung
'
' Kreuzung (Konsolenanwendung) mit bedarfsgesteuerter Fußgängerphase
'     Lampen : Grün = O1, Gelb = O2, Rot = O3, FußGrün = O4, FußRot = O5
'              QuerGrün = O6, QuerGelb = O7, QuerRot = O8
'     Tasten : FußWunsch = I1
'
' erforderlich : FishFa2005.DLL und umFish40.DLL
'
' ------------------------------------------------------------------------------

Imports FishFace40

Module FishKurs3b
  Private ft As New FishFace()
  Private FussWunsch As Boolean = False

  Public Const cGruen = 1, cGelb = 2, cRot = 4
  Const cFussGruen = 8, cFussRot = 16
  Const cQuerGruen = 32, cQuerGelb = 64, cQuerRot = 128
  Const iFussWunsch As Inp = Inp.I1

  Private TagListe() As Integer = {cGruen + cFussRot + cQuerRot, _
                                   cGruen + cFussRot + cQuerRot, _
                                   cGruen + cFussRot + cQuerRot, _
                                   cGelb + cFussRot + cQuerGelb + cQuerRot, _
                                   cRot + cFussRot + cQuerGruen, _
                                   cGelb + cRot + cFussRot + cQuerGelb, _
                                   cGelb + cRot + cFussRot + cQuerGelb, _
                                   cGelb + cRot + cFussRot + cQuerGelb}

  Private FussListe() As Integer = {cGruen + cFussGruen + cQuerRot, _
                                   cGruen + cFussGruen + cQuerRot, _
                                   cGruen + cFussGruen + cQuerRot, _
                                   cGelb + cFussRot + cQuerGelb + cQuerRot, _
                                   cRot + cFussRot + cQuerGruen, _
                                   cGelb + cRot + cFussRot + cQuerGelb, _
                                   cGelb + cRot + cFussRot + cQuerGelb, _
                                   cGelb + cRot + cFussRot + cQuerGelb}

  Private Sub Zyklus(ByVal Liste() As Integer)
    For i As Integer = 0 To Liste.Length - 1
      ft.SetMotors(Liste(i))
      If ft.GetInput(iFussWunsch) And Not FussWunsch Then
        Console.WriteLine("Signal     kommt")
        FussWunsch = True
      End If
      ft.Pause(1000)
    Next
  End Sub

  Private Sub NachtZyklus()
    ft.SetMotors(cGelb + cQuerGelb)
    ft.Pause(666)
    ft.ClearMotors()
    ft.Pause(333)
  End Sub

  Sub Main()
    Console.WriteLine("--- FishKurs3b : gestartet ---")
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)

      Console.WriteLine("--- Verbindung zum Interface hergestellt ---")
      Console.WriteLine("--- Ampelschleife läuft, Abbruch durch ESC-Taste ---")

      Do                                     ' --- Betriebsschleife Ampelanzeige ---
        If TimeString > #6:00:00 AM# And TimeString < #11:00:00 PM# Then
          If FussWunsch Then
            Console.WriteLine("FussZyklus laeuft")
            Zyklus(FussListe)
            FussWunsch = False
          Else
            Console.WriteLine("TagZyklus  laeuft")
            Zyklus(TagListe)
          End If
        Else
          NachtZyklus()
        End If
      Loop Until ft.Finish()                  ' --- Ende durch ESC-Taste
    Catch eft As FishFaceException
      Console.WriteLine(eft.Message)
    End Try

    ft.CloseInterface()
    Console.WriteLine("--- Beenden durch RETURN ---")
    Console.ReadLine()
  End Sub

End Module
