' ------------------------------------------------------------------------------
'
' FishKurs2W.VB                                           Ulrich Mller 22.06.06
'                                                         PCS1700 VB2005 Express
' Einfhrung in die Programmierung mit VB2005 und FishFace40
'            Windows-Lsung am Beispiel einer Ampelsteuerung
'
' FishKurs2 : Fugngerampel : Nachtschaltung Blinken
'             Lampen : Grn = O1, Gelb = O2, Rot = O3, FuGrn = O4, FuRot = O5
'             Taster : Nacht = I1 (Schlieer)
'
' erforderlich : FishFa2005.DLL und umFish40.DLL
'
' ------------------------------------------------------------------------------
Imports FishFace40

Public Class FishKurs2W

  Private ft As New FishFace()

  Const oRot As Out = Out.O3
  Const oGelb As Out = Out.O2
  Const oGruen As Out = Out.O1
  Const oFussGruen As Out = Out.O4
  Const oFussRot As Out = Out.O5
  Const iNacht As Inp = Inp.I1

  Private Sub NachtZyklus()
    ' --- Gelb blinken bei Nacht ---
    ft.SetLamp(oFussRot, Dir.Aus)
    ft.SetLamp(oGelb, Dir.Ein)
    ft.Pause(700)
    ft.SetLamp(oGelb, Dir.Aus)
    ft.Pause(250)
  End Sub


  Private Sub TagZyklus()
    ' --- Normaler Ampelzyklus am Tage ---
    ft.SetLamp(oGruen, Dir.Ein)         '     Grn, 3000
    ft.SetLamp(oFussRot, Dir.Ein)
    ft.Pause(3000)
    ft.SetLamp(oGruen, Dir.Aus)
    ft.SetLamp(oGelb, Dir.Ein)          '     Gelb, 1000
    ft.Pause(1000)
    ft.SetLamp(oGelb, Dir.Aus)
    ft.SetLamp(oRot, Dir.Ein)           '     Rot, 3500
    ft.SetLamp(oFussRot, Dir.Aus)
    ft.SetLamp(oFussGruen, Dir.Ein)
    ft.Pause(3500)
    ft.SetLamp(oFussGruen, Dir.Aus)
    ft.SetLamp(oFussRot, Dir.Ein)
    ft.SetLamp(oGelb, Dir.Ein)          '     Rot/Gelb, 1000
    ft.Pause(1000)
    ft.SetLamp(oRot, Dir.Aus)
    ft.SetLamp(oGelb, Dir.Aus)
  End Sub

  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAction.Click
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      lblStatus.Text = "Ampelschleife luft"
      cmdEnde.Text = "HALT"
      cmdAction.Enabled = False
      Do                                     ' --- Betriebsschleife Ampelanzeige ---
        Select Case TimeString
          ' --- Zyklusbestimmung, wenn man nicht warten will, auch mit iNacht
          Case #6:00:00 AM# To #10:00:00 PM#
            If ft.GetInput(iNacht) Then NachtZyklus() Else TagZyklus()
          Case Else
            NachtZyklus()
        End Select
      Loop Until ft.Finish()                  ' --- Ende durch ESC-Taste oder ft.NotHalt
      lblStatus.Text = "Ampelschleife beendet"
      cmdEnde.Text = "ENDE"
      cmdAction.Enabled = True
      ft.CloseInterface()
    Catch eft As FishFaceException
      lblStatus.Text = eft.Message
    End Try
  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    If cmdEnde.Text = "HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub FishKurs2W_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    If cmdEnde.Text = "HALT" Then e.Cancel = True
  End Sub
End Class
