﻿' ------------------------------------------------------------------------------
'
' FishKurs2bW.VB                                          Ulrich Müller 22.06.06
'                                                         PCS1700 VB2005 Express
' Einführung in die Programmierung mit VB2005 und FishFace40
'            Windows-Lösung am Beispiel einer Ampelsteuerung
'
' FishKurs2 : Fußgängerampel : Bedarfsschaltung, Nachtabschaltung
'             Lampen : Grün = O1, Gelb = O2, Rot = O3, FußGrün = O4, FußRot = O5
'             Taster : FußWunsch = I1 (Schließer)
'
' erforderlich : FishFa2005.DLL und umFish40.DLL
'
' ------------------------------------------------------------------------------

Imports FishFace40
Public Class FishKurs2bW

  Private ft As New FishFace()
  Private FussWunsch As Boolean = False

  Const oRot As Out = Out.O3
  Const oGelb As Out = Out.O2
  Const oGruen As Out = Out.O1
  Const oFussGruen As Out = Out.O4
  Const oFussRot As Out = Out.O5
  Const iFussWunsch As Inp = Inp.I1

  Private Sub FussZyklus()
    ' --- Ampelzyklus Fußgänger ---
    ft.SetLamp(oGruen, Dir.Aus)
    ft.SetLamp(oGelb, Dir.Ein)          '     Gelb, 1000
    ft.Pause(1000)
    ft.SetLamp(oGelb, Dir.Aus)
    ft.SetLamp(oRot, Dir.Ein)           '     Rot, 3500
    ft.SetLamp(oFussRot, Dir.Aus)
    ft.SetLamp(oFussGruen, Dir.Ein)
    ft.Pause(3500)
    ft.SetLamp(oFussGruen, Dir.Aus)
    ft.SetLamp(oFussRot, Dir.Ein)
    ft.SetLamp(oGelb, Dir.Ein)          '     Rot/Gelb, 1000
    ft.Pause(1000)
    ft.SetLamp(oRot, Dir.Aus)
    ft.SetLamp(oGelb, Dir.Aus)
    ft.SetLamp(oGruen, Dir.Ein)         '     Grün, 3000
    ft.SetLamp(oFussRot, Dir.Ein)
    ft.Pause(3000)
    FussWunsch = False
  End Sub

  Private Sub NachtAbschaltung()
    ft.ClearMotors()
    ft.Pause(10000)
  End Sub

  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAction.Click
    Dim VonZeit As DateTime = mskVonZeit.Text
    Dim BisZeit As DateTime = mskBisZeit.Text
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      lblStatus.Text = "Ampelschleife läuft"
      cmdEnde.Text = "HALT"
      cmdAction.Enabled = False
      ft.SetLamp(oGruen, Dir.Ein)
      ft.SetLamp(oFussRot, Dir.Ein)
      Do                                     ' --- Betriebsschleife Ampelanzeige ---
        Select Case TimeString
          ' --- Zyklusbestimmung ---
          Case VonZeit To BisZeit
            If ft.GetInput(iFussWunsch) Or FussWunsch Then FussZyklus()
          Case Else
            NachtAbschaltung()
        End Select
      Loop Until ft.Finish()                  ' --- Ende durch ESC-Taste oder ft.NotHalt
      lblStatus.Text = "Ampelschleife beendet"
      cmdEnde.Text = "ENDE"
      cmdAction.Enabled = True
      ft.CloseInterface()
    Catch eft As FishFaceException
      lblStatus.Text = eft.Message
    End Try

  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    If cmdEnde.Text = "HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub FishKurs2bW_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    If cmdEnde.Text = "HALT" Then e.Cancel = True
  End Sub

  Private Sub cmdFussWunsch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdFussWunsch.Click
    FussWunsch = True
  End Sub
End Class